# coding: utf-8

"""
    Trend Micro Deep Security API

    Copyright 2018 - 2021 Trend Micro Incorporated.<br/>Get protected, stay secured, and keep informed with Trend Micro Deep Security's new RESTful API. Access system data and manage security configurations to automate your security workflows and integrate Deep Security into your CI/CD pipeline.  # noqa: E501

    OpenAPI spec version: 20.0.463
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


from __future__ import absolute_import

import re  # noqa: F401

# python 2 and python 3 compatibility library
import six

from deepsecurity.api_client import ApiClient


class StatefulConfigurationsApi(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    Ref: https://github.com/swagger-api/swagger-codegen
    """

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient()
        self.api_client = api_client

    def create_stateful_configuration(self, stateful_configurations, api_version, **kwargs):  # noqa: E501
        """Create a Stateful Configuration  # noqa: E501

        Create a new stateful configuration.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.create_stateful_configuration(stateful_configurations, api_version, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param StatefulConfiguration stateful_configurations: The settings of the new stateful configuration. (required)
        :param str api_version: The version of the api being called. (required)
        :return: StatefulConfiguration
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.create_stateful_configuration_with_http_info(stateful_configurations, api_version, **kwargs)  # noqa: E501
        else:
            (data) = self.create_stateful_configuration_with_http_info(stateful_configurations, api_version, **kwargs)  # noqa: E501
            return data

    def create_stateful_configuration_with_http_info(self, stateful_configurations, api_version, **kwargs):  # noqa: E501
        """Create a Stateful Configuration  # noqa: E501

        Create a new stateful configuration.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.create_stateful_configuration_with_http_info(stateful_configurations, api_version, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param StatefulConfiguration stateful_configurations: The settings of the new stateful configuration. (required)
        :param str api_version: The version of the api being called. (required)
        :return: StatefulConfiguration
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['stateful_configurations', 'api_version']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method create_stateful_configuration" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'stateful_configurations' is set
        if ('stateful_configurations' not in params or
                params['stateful_configurations'] is None):
            raise ValueError("Missing the required parameter `stateful_configurations` when calling `create_stateful_configuration`")  # noqa: E501
        # verify the required parameter 'api_version' is set
        if ('api_version' not in params or
                params['api_version'] is None):
            raise ValueError("Missing the required parameter `api_version` when calling `create_stateful_configuration`")  # noqa: E501

        collection_formats = {}

        path_params = {}

        query_params = []

        header_params = {}
        if 'api_version' in params:
            header_params['api-version'] = params['api_version']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        if 'stateful_configurations' in params:
            body_params = params['stateful_configurations']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['DefaultAuthentication']  # noqa: E501

        return self.api_client.call_api(
            '/statefulconfigurations', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='StatefulConfiguration',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def delete_stateful_configuration(self, stateful_configuration_id, api_version, **kwargs):  # noqa: E501
        """Delete a Stateful Configuration  # noqa: E501

        Delete a stateful configuration by ID.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.delete_stateful_configuration(stateful_configuration_id, api_version, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param int stateful_configuration_id: The ID number of the stateful configuration to delete. (required)
        :param str api_version: The version of the api being called. (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.delete_stateful_configuration_with_http_info(stateful_configuration_id, api_version, **kwargs)  # noqa: E501
        else:
            (data) = self.delete_stateful_configuration_with_http_info(stateful_configuration_id, api_version, **kwargs)  # noqa: E501
            return data

    def delete_stateful_configuration_with_http_info(self, stateful_configuration_id, api_version, **kwargs):  # noqa: E501
        """Delete a Stateful Configuration  # noqa: E501

        Delete a stateful configuration by ID.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.delete_stateful_configuration_with_http_info(stateful_configuration_id, api_version, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param int stateful_configuration_id: The ID number of the stateful configuration to delete. (required)
        :param str api_version: The version of the api being called. (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['stateful_configuration_id', 'api_version']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method delete_stateful_configuration" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'stateful_configuration_id' is set
        if ('stateful_configuration_id' not in params or
                params['stateful_configuration_id'] is None):
            raise ValueError("Missing the required parameter `stateful_configuration_id` when calling `delete_stateful_configuration`")  # noqa: E501
        # verify the required parameter 'api_version' is set
        if ('api_version' not in params or
                params['api_version'] is None):
            raise ValueError("Missing the required parameter `api_version` when calling `delete_stateful_configuration`")  # noqa: E501

        if 'stateful_configuration_id' in params and not re.search('\\d+', str(params['stateful_configuration_id'])):  # noqa: E501
            raise ValueError("Invalid value for parameter `stateful_configuration_id` when calling `delete_stateful_configuration`, must conform to the pattern `/\\d+/`")  # noqa: E501
        collection_formats = {}

        path_params = {}
        if 'stateful_configuration_id' in params:
            path_params['statefulConfigurationID'] = params['stateful_configuration_id']  # noqa: E501

        query_params = []

        header_params = {}
        if 'api_version' in params:
            header_params['api-version'] = params['api_version']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['DefaultAuthentication']  # noqa: E501

        return self.api_client.call_api(
            '/statefulconfigurations/{statefulConfigurationID}', 'DELETE',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type=None,  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def describe_stateful_configuration(self, stateful_configuration_id, api_version, **kwargs):  # noqa: E501
        """Describe a Stateful Configuration  # noqa: E501

        Describe a stateful configuration by ID.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.describe_stateful_configuration(stateful_configuration_id, api_version, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param int stateful_configuration_id: The ID number of the stateful configuration to describe. (required)
        :param str api_version: The version of the api being called. (required)
        :return: StatefulConfiguration
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.describe_stateful_configuration_with_http_info(stateful_configuration_id, api_version, **kwargs)  # noqa: E501
        else:
            (data) = self.describe_stateful_configuration_with_http_info(stateful_configuration_id, api_version, **kwargs)  # noqa: E501
            return data

    def describe_stateful_configuration_with_http_info(self, stateful_configuration_id, api_version, **kwargs):  # noqa: E501
        """Describe a Stateful Configuration  # noqa: E501

        Describe a stateful configuration by ID.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.describe_stateful_configuration_with_http_info(stateful_configuration_id, api_version, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param int stateful_configuration_id: The ID number of the stateful configuration to describe. (required)
        :param str api_version: The version of the api being called. (required)
        :return: StatefulConfiguration
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['stateful_configuration_id', 'api_version']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method describe_stateful_configuration" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'stateful_configuration_id' is set
        if ('stateful_configuration_id' not in params or
                params['stateful_configuration_id'] is None):
            raise ValueError("Missing the required parameter `stateful_configuration_id` when calling `describe_stateful_configuration`")  # noqa: E501
        # verify the required parameter 'api_version' is set
        if ('api_version' not in params or
                params['api_version'] is None):
            raise ValueError("Missing the required parameter `api_version` when calling `describe_stateful_configuration`")  # noqa: E501

        if 'stateful_configuration_id' in params and not re.search('\\d+', str(params['stateful_configuration_id'])):  # noqa: E501
            raise ValueError("Invalid value for parameter `stateful_configuration_id` when calling `describe_stateful_configuration`, must conform to the pattern `/\\d+/`")  # noqa: E501
        collection_formats = {}

        path_params = {}
        if 'stateful_configuration_id' in params:
            path_params['statefulConfigurationID'] = params['stateful_configuration_id']  # noqa: E501

        query_params = []

        header_params = {}
        if 'api_version' in params:
            header_params['api-version'] = params['api_version']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['DefaultAuthentication']  # noqa: E501

        return self.api_client.call_api(
            '/statefulconfigurations/{statefulConfigurationID}', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='StatefulConfiguration',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def list_stateful_configurations(self, api_version, **kwargs):  # noqa: E501
        """List Stateful Configurations  # noqa: E501

        Lists all stateful configurations.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.list_stateful_configurations(api_version, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str api_version: The version of the api being called. (required)
        :return: StatefulConfigurations
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.list_stateful_configurations_with_http_info(api_version, **kwargs)  # noqa: E501
        else:
            (data) = self.list_stateful_configurations_with_http_info(api_version, **kwargs)  # noqa: E501
            return data

    def list_stateful_configurations_with_http_info(self, api_version, **kwargs):  # noqa: E501
        """List Stateful Configurations  # noqa: E501

        Lists all stateful configurations.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.list_stateful_configurations_with_http_info(api_version, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str api_version: The version of the api being called. (required)
        :return: StatefulConfigurations
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['api_version']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method list_stateful_configurations" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'api_version' is set
        if ('api_version' not in params or
                params['api_version'] is None):
            raise ValueError("Missing the required parameter `api_version` when calling `list_stateful_configurations`")  # noqa: E501

        collection_formats = {}

        path_params = {}

        query_params = []

        header_params = {}
        if 'api_version' in params:
            header_params['api-version'] = params['api_version']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['DefaultAuthentication']  # noqa: E501

        return self.api_client.call_api(
            '/statefulconfigurations', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='StatefulConfigurations',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def modify_stateful_configuration(self, stateful_configuration_id, stateful_configuration, api_version, **kwargs):  # noqa: E501
        """Modify a Stateful Configuration  # noqa: E501

        Modify a stateful configuration by ID. Any unset elements will be left unchanged.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.modify_stateful_configuration(stateful_configuration_id, stateful_configuration, api_version, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param int stateful_configuration_id: The ID number of the stateful configuration to modify. (required)
        :param StatefulConfiguration stateful_configuration: The settings of the stateful configuration to modify. (required)
        :param str api_version: The version of the api being called. (required)
        :return: StatefulConfiguration
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.modify_stateful_configuration_with_http_info(stateful_configuration_id, stateful_configuration, api_version, **kwargs)  # noqa: E501
        else:
            (data) = self.modify_stateful_configuration_with_http_info(stateful_configuration_id, stateful_configuration, api_version, **kwargs)  # noqa: E501
            return data

    def modify_stateful_configuration_with_http_info(self, stateful_configuration_id, stateful_configuration, api_version, **kwargs):  # noqa: E501
        """Modify a Stateful Configuration  # noqa: E501

        Modify a stateful configuration by ID. Any unset elements will be left unchanged.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.modify_stateful_configuration_with_http_info(stateful_configuration_id, stateful_configuration, api_version, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param int stateful_configuration_id: The ID number of the stateful configuration to modify. (required)
        :param StatefulConfiguration stateful_configuration: The settings of the stateful configuration to modify. (required)
        :param str api_version: The version of the api being called. (required)
        :return: StatefulConfiguration
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['stateful_configuration_id', 'stateful_configuration', 'api_version']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method modify_stateful_configuration" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'stateful_configuration_id' is set
        if ('stateful_configuration_id' not in params or
                params['stateful_configuration_id'] is None):
            raise ValueError("Missing the required parameter `stateful_configuration_id` when calling `modify_stateful_configuration`")  # noqa: E501
        # verify the required parameter 'stateful_configuration' is set
        if ('stateful_configuration' not in params or
                params['stateful_configuration'] is None):
            raise ValueError("Missing the required parameter `stateful_configuration` when calling `modify_stateful_configuration`")  # noqa: E501
        # verify the required parameter 'api_version' is set
        if ('api_version' not in params or
                params['api_version'] is None):
            raise ValueError("Missing the required parameter `api_version` when calling `modify_stateful_configuration`")  # noqa: E501

        if 'stateful_configuration_id' in params and not re.search('\\d+', str(params['stateful_configuration_id'])):  # noqa: E501
            raise ValueError("Invalid value for parameter `stateful_configuration_id` when calling `modify_stateful_configuration`, must conform to the pattern `/\\d+/`")  # noqa: E501
        collection_formats = {}

        path_params = {}
        if 'stateful_configuration_id' in params:
            path_params['statefulConfigurationID'] = params['stateful_configuration_id']  # noqa: E501

        query_params = []

        header_params = {}
        if 'api_version' in params:
            header_params['api-version'] = params['api_version']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        if 'stateful_configuration' in params:
            body_params = params['stateful_configuration']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['DefaultAuthentication']  # noqa: E501

        return self.api_client.call_api(
            '/statefulconfigurations/{statefulConfigurationID}', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='StatefulConfiguration',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def search_stateful_configurations(self, api_version, **kwargs):  # noqa: E501
        """Search Stateful Configurations  # noqa: E501

        Search for stateful configurations using optional filters.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.search_stateful_configurations(api_version, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str api_version: The version of the api being called. (required)
        :param SearchFilter search_filter: A collection of options used to filter the search results.
        :return: StatefulConfigurations
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.search_stateful_configurations_with_http_info(api_version, **kwargs)  # noqa: E501
        else:
            (data) = self.search_stateful_configurations_with_http_info(api_version, **kwargs)  # noqa: E501
            return data

    def search_stateful_configurations_with_http_info(self, api_version, **kwargs):  # noqa: E501
        """Search Stateful Configurations  # noqa: E501

        Search for stateful configurations using optional filters.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.search_stateful_configurations_with_http_info(api_version, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str api_version: The version of the api being called. (required)
        :param SearchFilter search_filter: A collection of options used to filter the search results.
        :return: StatefulConfigurations
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['api_version', 'search_filter']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method search_stateful_configurations" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'api_version' is set
        if ('api_version' not in params or
                params['api_version'] is None):
            raise ValueError("Missing the required parameter `api_version` when calling `search_stateful_configurations`")  # noqa: E501

        collection_formats = {}

        path_params = {}

        query_params = []

        header_params = {}
        if 'api_version' in params:
            header_params['api-version'] = params['api_version']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        if 'search_filter' in params:
            body_params = params['search_filter']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['DefaultAuthentication']  # noqa: E501

        return self.api_client.call_api(
            '/statefulconfigurations/search', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='StatefulConfigurations',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)
