# coding: utf-8

"""
    Trend Micro Deep Security API

    Copyright 2018 - 2021 Trend Micro Incorporated.<br/>Get protected, stay secured, and keep informed with Trend Micro Deep Security's new RESTful API. Access system data and manage security configurations to automate your security workflows and integrate Deep Security into your CI/CD pipeline.  # noqa: E501

    OpenAPI spec version: 20.0.463
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six


class WorkloadSecurityLink(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'workload_security_tenant_guid': 'str',
        'workload_security_url': 'str',
        'workload_security_api_key': 'str',
        'workload_security_ca': 'str',
        'id': 'int'
    }

    attribute_map = {
        'workload_security_tenant_guid': 'workloadSecurityTenantGUID',
        'workload_security_url': 'workloadSecurityUrl',
        'workload_security_api_key': 'workloadSecurityAPIKey',
        'workload_security_ca': 'workloadSecurityCA',
        'id': 'ID'
    }

    def __init__(self, workload_security_tenant_guid=None, workload_security_url=None, workload_security_api_key=None, workload_security_ca=None, id=None):  # noqa: E501
        """WorkloadSecurityLink - a model defined in Swagger"""  # noqa: E501

        self._workload_security_tenant_guid = None
        self._workload_security_url = None
        self._workload_security_api_key = None
        self._workload_security_ca = None
        self._id = None
        self.discriminator = None

        if workload_security_tenant_guid is not None:
            self.workload_security_tenant_guid = workload_security_tenant_guid
        if workload_security_url is not None:
            self.workload_security_url = workload_security_url
        if workload_security_api_key is not None:
            self.workload_security_api_key = workload_security_api_key
        if workload_security_ca is not None:
            self.workload_security_ca = workload_security_ca
        if id is not None:
            self.id = id

    @property
    def workload_security_tenant_guid(self):
        """Gets the workload_security_tenant_guid of this WorkloadSecurityLink.  # noqa: E501

        Tenant GUID on Workload Security.  # noqa: E501

        :return: The workload_security_tenant_guid of this WorkloadSecurityLink.  # noqa: E501
        :rtype: str
        """
        return self._workload_security_tenant_guid

    @workload_security_tenant_guid.setter
    def workload_security_tenant_guid(self, workload_security_tenant_guid):
        """Sets the workload_security_tenant_guid of this WorkloadSecurityLink.

        Tenant GUID on Workload Security.  # noqa: E501

        :param workload_security_tenant_guid: The workload_security_tenant_guid of this WorkloadSecurityLink.  # noqa: E501
        :type: str
        """

        self._workload_security_tenant_guid = workload_security_tenant_guid

    @property
    def workload_security_url(self):
        """Gets the workload_security_url of this WorkloadSecurityLink.  # noqa: E501

        URL of Workload Security.  # noqa: E501

        :return: The workload_security_url of this WorkloadSecurityLink.  # noqa: E501
        :rtype: str
        """
        return self._workload_security_url

    @workload_security_url.setter
    def workload_security_url(self, workload_security_url):
        """Sets the workload_security_url of this WorkloadSecurityLink.

        URL of Workload Security.  # noqa: E501

        :param workload_security_url: The workload_security_url of this WorkloadSecurityLink.  # noqa: E501
        :type: str
        """

        self._workload_security_url = workload_security_url

    @property
    def workload_security_api_key(self):
        """Gets the workload_security_api_key of this WorkloadSecurityLink.  # noqa: E501

        API key of Workload Security.  # noqa: E501

        :return: The workload_security_api_key of this WorkloadSecurityLink.  # noqa: E501
        :rtype: str
        """
        return self._workload_security_api_key

    @workload_security_api_key.setter
    def workload_security_api_key(self, workload_security_api_key):
        """Sets the workload_security_api_key of this WorkloadSecurityLink.

        API key of Workload Security.  # noqa: E501

        :param workload_security_api_key: The workload_security_api_key of this WorkloadSecurityLink.  # noqa: E501
        :type: str
        """

        self._workload_security_api_key = workload_security_api_key

    @property
    def workload_security_ca(self):
        """Gets the workload_security_ca of this WorkloadSecurityLink.  # noqa: E501

        Pinned public certificate for agents of Workload Security.  # noqa: E501

        :return: The workload_security_ca of this WorkloadSecurityLink.  # noqa: E501
        :rtype: str
        """
        return self._workload_security_ca

    @workload_security_ca.setter
    def workload_security_ca(self, workload_security_ca):
        """Sets the workload_security_ca of this WorkloadSecurityLink.

        Pinned public certificate for agents of Workload Security.  # noqa: E501

        :param workload_security_ca: The workload_security_ca of this WorkloadSecurityLink.  # noqa: E501
        :type: str
        """

        self._workload_security_ca = workload_security_ca

    @property
    def id(self):
        """Gets the id of this WorkloadSecurityLink.  # noqa: E501

        ID of the Workload Security Link.  # noqa: E501

        :return: The id of this WorkloadSecurityLink.  # noqa: E501
        :rtype: int
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this WorkloadSecurityLink.

        ID of the Workload Security Link.  # noqa: E501

        :param id: The id of this WorkloadSecurityLink.  # noqa: E501
        :type: int
        """

        self._id = id

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(WorkloadSecurityLink, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, WorkloadSecurityLink):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other

